unit calculate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ExtCtrls, stypes;

type
  TFmCalculate = class(TForm)
    PnTop: TPanel;
    ScrollBox1: TScrollBox;
    GbState: TGroupBox;
    LblStateCl: TLabel;
    LblStateClUnits: TLabel;
    LblStateCw: TLabel;
    LblStateCwUnits: TLabel;
    LblStateCr: TLabel;
    LblStateCrUnits: TLabel;
    LblStateNl: TLabel;
    LblStateNlUnits: TLabel;
    LblStateNw: TLabel;
    LblStateNwUnits: TLabel;
    LblStateNr: TLabel;
    LblStateNrUnits: TLabel;
    MeStateCl: TMaskEdit;
    MeStateCw: TMaskEdit;
    MeStateNw: TMaskEdit;
    MeStateNr: TMaskEdit;
    MeStateCr: TMaskEdit;
    MeStateNl: TMaskEdit;
    GbDriver: TGroupBox;
    LblDriveCa: TLabel;
    LblDriveCaUnits: TLabel;
    LblDriveTamax: TLabel;
    LblDriveTamin: TLabel;
    LblDriveI: TLabel;
    LblDriveTamaxUnits: TLabel;
    LblDriveTaminUnits: TLabel;
    LblDriveIUnits: TLabel;
    MeDriveCa: TMaskEdit;
    MeDriveTamax: TMaskEdit;
    MeDriveTamin: TMaskEdit;
    MeDriveI: TMaskEdit;
    GbPResp: TGroupBox;
    LblRpt: TLabel;
    LblPar_rm: TLabel;
    LblPar_rc: TLabel;
    LblRptUnits: TLabel;
    LblPar_rmUnits: TLabel;
    LblPar_rcUnits: TLabel;
    MeRpt: TMaskEdit;
    MePar_rm: TMaskEdit;
    MePar_rc: TMaskEdit;
    GbSapwood: TGroupBox;
    LblCsw: TLabel;
    LblPar_h1: TLabel;
    LblPar_h2: TLabel;
    LblCswUnits: TLabel;
    LblPar_h1Units: TLabel;
    LblPar_h2Units: TLabel;
    MeCsw: TMaskEdit;
    MePar_h1: TMaskEdit;
    MePar_h2: TMaskEdit;
    GbAllocation: TGroupBox;
    LblPar_qL: TLabel;
    LblPar_qW: TLabel;
    LblPar_qR: TLabel;
    LblPar_aCL: TLabel;
    LblPar_aCW: TLabel;
    LblPar_aCR: TLabel;
    LblPar_aNL: TLabel;
    LblPar_aNW: TLabel;
    LblPar_aNR: TLabel;
    LblPar_gammaL: TLabel;
    LblPar_gammaW: TLabel;
    LblPar_gammaR: TLabel;
    LblomegaCa: TLabel;
    LblomegaCb: TLabel;
    LblomegaNa: TLabel;
    LblomegaNb: TLabel;
    LblPar_aCLUnits: TLabel;
    LblPar_aCWUnits: TLabel;
    LblPar_aCRUnits: TLabel;
    LblomegaCaUnits: TLabel;
    LblomegaCbUnits: TLabel;
    LblPar_aNLUnits: TLabel;
    LblPar_aNWUnits: TLabel;
    LblPar_aNRUnits: TLabel;
    LblomegaNaUnits: TLabel;
    LblomegaNbUnits: TLabel;
    MePar_qL: TMaskEdit;
    MePar_gammaL: TMaskEdit;
    MePar_qW: TMaskEdit;
    MePar_gammaW: TMaskEdit;
    MePar_qR: TMaskEdit;
    MePar_gammaR: TMaskEdit;
    MePar_aCL: TMaskEdit;
    MePar_aCW: TMaskEdit;
    MePar_aCR: TMaskEdit;
    MeomegaCb: TMaskEdit;
    MeomegaCa: TMaskEdit;
    MePar_aNL: TMaskEdit;
    MePar_aNW: TMaskEdit;
    MePar_aNR: TMaskEdit;
    MeomegaNa: TMaskEdit;
    MeomegaNb: TMaskEdit;
    GbNPP: TGroupBox;
    LbllambdaCWUnits: TLabel;
    LbllambdaCL: TLabel;
    LbllambdaCW: TLabel;
    LbllambdaCR: TLabel;
    LbllambdaCLUnits: TLabel;
    LbllambdaCRUnits: TLabel;
    LblPar_AlambdaL: TLabel;
    LblPar_AlambdaW: TLabel;
    LblPar_AlambdaR: TLabel;
    LblPar_AlambdaLUnits: TLabel;
    LblPar_AlambdaWUnits: TLabel;
    LblPar_AlambdaRUnits: TLabel;
    MelambdaCL: TMaskEdit;
    MelambdaCW: TMaskEdit;
    MelambdaCR: TMaskEdit;
    MePar_AlambdaL: TMaskEdit;
    MePar_AlambdaW: TMaskEdit;
    MePar_AlambdaR: TMaskEdit;
    GbTranslocation: TGroupBox;
    LblTn: TLabel;
    LblPar_aT: TLabel;
    LblTnUnits: TLabel;
    LblPar_aTUnits: TLabel;
    MeTn: TMaskEdit;
    MePar_aT: TMaskEdit;
    BtnShowallProc: TButton;
    BtnCancel: TButton;
    RgLabelType: TRadioGroup;
    BtnOK: TButton;
    LblDriveNNH4aq: TLabel;
    MeDriveNNH4aq: TMaskEdit;
    LblDriveNNH4aqUnits: TLabel;
    GbStatus: TGroupBox;
    ShStatus: TShape;
    LbllambdaNL: TLabel;
    MelambdaNL: TMaskEdit;
    LbllambdaNLUnits: TLabel;
    LbllambdaNW: TLabel;
    MelambdaNW: TMaskEdit;
    LbllambdaNWUnits: TLabel;
    LbllambdaNR: TLabel;
    MelambdaNR: TMaskEdit;
    LbllambdaNRUnits: TLabel;
    LblNPPl: TLabel;
    MeNPPl: TMaskEdit;
    LblNPPlUnits: TLabel;
    LblNPPw: TLabel;
    MeNPPw: TMaskEdit;
    LblNPPwUnits: TLabel;
    LblNPPr: TLabel;
    MeNPPr: TMaskEdit;
    LblNPPrUnits: TLabel;
    BtnSaveParamFile: TButton;
    MeNPPt: TMaskEdit;
    LblNPPt: TLabel;
    LblNPPtUnits: TLabel;
    LblPar_aCa: TLabel;
    LblPar_aCb: TLabel;
    MePar_aCa: TMaskEdit;
    MePar_aCb: TMaskEdit;
    LblPar_aCaUnits: TLabel;
    LblPar_aCbUnits: TLabel;
    LblPar_aNa: TLabel;
    LblPar_aNb: TLabel;
    MePar_aNa: TMaskEdit;
    MePar_aNb: TMaskEdit;
    LblPar_aNbUnits: TLabel;
    LblPar_aNaUnits: TLabel;
    LblDriveUnh4: TLabel;
    MeDriveUnh4: TMaskEdit;
    LblDriveUnh4Units: TLabel;
    LblPar_ml: TLabel;
    MePar_ml: TMaskEdit;
    LblPar_mlUnits: TLabel;
    LblDrivePs: TLabel;
    MeDrivePs: TMaskEdit;
    LblDrivePsUnits: TLabel;
    procedure FormSetup(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UpdateForm(Sender: TObject; CalSteadyState:Boolean);
    procedure StoreValue(Sender: TObject);
    procedure RgLabelTypeClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnShowallProcClick(Sender: TObject);
    procedure CalculateSteadyState(Sender: TObject);
    function CheckValue(Sender:TObject):Boolean;
    procedure UpdateFormValues;
    procedure GeneralKeyPress(Sender: TObject; var Key: Char);
    procedure BtnSaveParamFileClick(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    function GetArrayIndex(VarType:TVarType; symbol: string):Integer;
    procedure EnableGroupBoxes(Sender: TObject);
    procedure DisableGroupBoxes(Sender: TObject);
    procedure ChangeValue(VarType:TVarType; arraynum:integer; newvalue:double);

  private
    { Private declarations }
    Foriginalstat:statearray;
    Foriginalpar:paramarray;
    Foriginaldrive:drivearray;
    Foriginalproc:processarray;
    Ftargetstat:statearray;
    Ftargetpar:paramarray;
    Ftargetdrive:drivearray;
    Ftargetproc:processarray;
    Ftempproc:processarray;
    FoverwriteConfirmed:Boolean;
    FCheckAlloc:Boolean;
  public
    { Public declarations }
    currentproc:processarray;
    currentstat:statearray;
    currentdrive:drivearray;
    currentpar:paramarray;
    property CheckAlloc:Boolean read FCheckAlloc
                                      write FCheckAlloc;
  end;

var
  FmCalculate: TFmCalculate;

implementation

uses frontend, equations, params, fileio, data;

{$R *.DFM}

{ This procedure changes the original generic names of objects on the form to
  names that match the real life names of the variables. To do this the
  procedure loops over all components in the form looking for labels and
  maskedits. For each label or maskedit it determines whether it refers to
  a state variable, driver variable, process variable, or parameter. Then it
  searches the appropriate array (stat, drive, proc, or par respectively) to
  find the array index, the appropriate name and units, and, if a parameter
  file and driver file were chosen, the current values. }
procedure TFmCalculate.FormSetup(Sender: TObject);
var
 i,j,number: integer;
 tempstring: string;
 UseNames: Boolean;
 CurrentLabel:Tlabel;
 CurrentMaskEdit:TMaskEdit;
begin  // FormSetup procedure
{ Determine whether to use names or symbols for variables and parameters,
  based on what's checked in the radio group.}
 if RgLabelType.ItemIndex = 0 then
  UseNames := True
 else
  UseNames := False;
 with FmCalculate do
 begin // with block
  for i := 0 to ComponentCount - 1 do   // for each component on the form
  begin
   if Components[i] is TLabel then   // Skip all components except labels
    begin
     CurrentLabel := Components[i] as Tlabel;
     tempstring := CurrentLabel.Name;
     if pos('State', CurrentLabel.Name) <> 0  then  // Current component is a state variable label
      begin  // if state
       Delete(tempstring,1,8); // Delete first 7 characters in component name
       j := pos('Units',tempstring);  // Check if this label is for the units or the name
       if j <> 0 then Delete(tempstring,j,5);
       number := GetArrayIndex(vtState,tempstring);
       CurrentLabel.Tag := number;
       if  j = 0 then
         begin
          if UseNames then
            CurrentLabel.caption := stat[number].name
          else
            CurrentLabel.caption := stat[number].symbol;
         end
       else
         begin
           CurrentLabel.caption := stat[number].units;
         end;
      end   // end if state
     else if pos('Drive', CurrentLabel.Name) <> 0 then   // Driver
      begin  // if
       Delete(tempstring,1,8);
       j := pos('Units',tempstring);
       if j <> 0 then Delete(tempstring,j,5);
       number := GetArrayIndex(vtDriver,tempstring);
       CurrentLabel.Tag := number;
       if  j = 0 then
         begin
           if UseNames then
             CurrentLabel.caption := drive[number].name
           else
             CurrentLabel.caption := drive[number].symbol;
         end
       else
         begin
           CurrentLabel.caption := drive[number].units;
         end;
      end // end if drive
     else if pos('Par', CurrentLabel.Name) <> 0 then    // Parameter
      begin
       Delete(tempstring,1,7);
       j := pos('Units',tempstring);
       if j <> 0 then Delete(tempstring,j,5);
       number := GetArrayIndex(vtParameter,tempstring);
       CurrentLabel.Tag := number;
       if  j = 0 then
         begin
           if UseNames then
             CurrentLabel.caption := par[number].name
           else
             CurrentLabel.caption := par[number].symbol;
         end
       else
         begin
           CurrentLabel.caption := par[number].units;
         end;
      end  // end if param
     else                                       // Process
      begin   // if
       Delete(tempstring,1,3);
       j := pos('Units',tempstring);
       if j <> 0 then Delete(tempstring,j,5);
       number := GetArrayIndex(vtProcess, tempstring);
       CurrentLabel.Tag := number;
       if  j = 0 then
         begin
          if UseNames then
            CurrentLabel.caption := proc[number].name
          else
            CurrentLabel.caption := proc[number].symbol;
         end
       else
         begin
           CurrentLabel.caption := proc[number].units;
         end;
      end;    // if process
    end  // if component is tlabel
   else if Components[i] is TMaskEdit then   // and now MaskEdits
    begin
     CurrentMaskEdit := Components[i] as TMaskEdit;
     tempstring := CurrentMaskEdit.Name;
     if pos('State', CurrentMaskEdit.Name) <> 0  then  // Current component is a state variable label
      begin  // if state
       Delete(tempstring,1,7); // Delete first 7 characters in component name
       number := GetArrayIndex(vtState,tempstring);
       CurrentMaskEdit.Tag := number;
      end   // end if state
     else if pos('Drive', CurrentMaskEdit.Name) <> 0 then   // Driver
      begin  // if driver
       Delete(tempstring,1,7);
       number := GetArrayIndex(vtDriver,tempstring);
       CurrentMaskEdit.Tag := number;
      end // end if drive
     else if pos('Par', CurrentMaskEdit.Name) <> 0 then    // Parameter
      begin
       Delete(tempstring,1,6);
       number := GetArrayIndex(vtParameter,tempstring);
       CurrentMaskEdit.Tag := number;
      end  // end if param
     else                                       // Process
      begin   // if
       Delete(tempstring,1,2);
       number := GetArrayIndex(vtProcess,tempstring);
       CurrentMaskEdit.Tag := number;
      end;    // if process
    end; // Maskedit
  end; // for each component
 end; // with block
end;  // end FormSetup procedure

{ This procedure updates all the values on the form before showing it. }
procedure TFmCalculate.FormShow(Sender: TObject);
begin  // FormShow procedure
 { Save the original arrays so that if the user choses cancel they can be
   restored. }
 FoverwriteConfirmed := False;
 Foriginalstat := stat;
 Foriginalpar := par;
 Foriginaldrive := drive;
 Foriginalproc := proc;
 currentstat := stat;
 currentpar := par;
 currentdrive := drive;        // Necessary to define names and units.
 currentproc := proc;          // Necessary to define names and units.
 Ftargetstat := stat;
 Ftargetpar := par;
 OpenDriverFile(driverfilename, ModelDef.numdrive, currentdrive, flread);
 next_time := 0;  last_time := 0;  // This forces the drivers to be reread from the driverfile.
 GetCurrentDrivers(CalTime,currentdrive);
 CloseDriverFile;
 Ftargetdrive := currentdrive;
 EnableGroupBoxes(FmCalculate);
 try
  CheckAlloc := False;
  processes(caltime,currentdrive,currentpar,currentstat,currentproc,false);
  Ftargetproc := currentproc;
  Ftempproc := currentproc;
  UpdateForm(Sender, False);
  if MainForm.RunningSensitivity then
   UpdateForm(Sender, True)
  else
   begin
     MePar_qL.SetFocus;
  //   MeDrivePs.SetFocus;
     if MessageDlg('Calculate steady state now?',mtConfirmation, [mbYes,mbNo],0)
                   = mrYes then UpdateForm(Sender, True);
   end;
 except
  { This exception block should only get triggered if the first call to
    processes fails. Any exceptions raised during steady state calculation
    should be handled in the updateform procedure. }
  if MainForm.RunningSensitivity then
    raise
  else
    MessageDlg('Cannot calculate process values. Steady state calculation ' +
      'aborted.',mtWarning, [mbOK], 0);

 end;
end; // FormShow procedure

{ Update the values and the Status button on the form. }
procedure TFmCalculate.UpdateForm(Sender: TObject; CalSteadyState: Boolean);
var
 i, negativevalues:integer;
 CurrentMaskEdit:TMaskEdit;
 steadystate:Boolean;
begin
   { Try to calculate the processes, on any errors, display message and then
     continue. Values shown in the window will not be correct. }
 steadystate := True;
 try
   CheckAlloc := False;
   if CalSteadyState then CalculateSteadyState(Sender);
 except
  on E: Exception do
    begin
     E.Message := 'Steady state calculation failed. ' + E.Message;
     if MainForm.RunningSensitivity then
      begin
        raise;
      end
     else
      begin
        MessageDlg(E.Message, mtError, [mbOK], 0);
//      steadystate := False;
        DisableGroupBoxes(FmCalculate);
        BtnCancel.SetFocus;
      end;
    end;
 end;
 UpdateFormValues;
// Check for negative parameter values.
 with FmCalculate do
   begin
     negativevalues := 0;
     for i := 0 to ComponentCount - 1 do
       begin
         if Components[i] is TMaskEdit then
           begin
             CurrentMaskEdit := TMaskEdit(Components[i]);
             if not CheckValue(CurrentMaskEdit)then
               begin
                 negativevalues := negativevalues + 1;
                 CurrentMaskEdit.color := clyellow;
               end
             else
               begin
                 if CurrentMaskEdit.enabled = true then
                    CurrentMaskEdit.color := clWindow
                 else
                    CurrentMaskEdit.color := clScrollBar;
               end;
           end;
       end;
   end;
// Check to be sure it's really a steady state.
 for i := 1 to ModelDef.numstate do
   begin
     if abs(currentproc[i].value) > 1E-8 then steadystate := false;
   end;
// Update form status.
 if (negativevalues = 0) and (steadystate) then
    ShStatus.Brush.Color := clgreen
 else
  begin
   if MainForm.RunningSensitivity then
    raise Exception.Create('Invalid Steady State')
   else
    ShStatus.Brush.Color := clred;
  end;

 if not MainForm.RunningSensitivity then
 if (DataForm.Visible = True) and (DataShowing = dtprocess) then
  begin
   stat := currentstat;
   drive := currentdrive;
   par := currentpar;
   proc := currentproc;
   DataForm.UpdateProcess; // Update the process values on the dataform.
  end;
end;

{Changes the labels on the form based on what the user chose in the radio group.}
procedure TFmCalculate.RgLabelTypeClick(Sender: TObject);
begin
 FmCalculate.FormSetup(RgLabelType);
end;

{ Restores original arrays because calculate was canceled.}
procedure TFmCalculate.BtnCancelClick(Sender: TObject);
begin
 if MessageDlg('Discard all changes made in this window since the last save?'
  ,mtConfirmation, [mbYes,mbNo], 0) = mrYes then
   begin
     stat := Foriginalstat;
     par := Foriginalpar;
     proc := Foriginalproc;
     drive := Foriginaldrive;
   end
 else
   begin
     stat := currentstat;
     par := currentpar;
     proc := currentproc;
     drive := currentdrive;
   end;

 if DataForm.Visible = True then DataForm.Hide;
end;

{ Stores the value in the current maskedit in the appropriate array. }
procedure TFmCalculate.StoreValue(Sender: TObject);
var
 number:integer;
 name:string;
 CurrentMaskEdit:TMaskEdit;
begin
 CurrentMaskEdit := Sender as TMaskEdit;
 if (CurrentMaskEdit.Modified) and (CurrentMaskEdit.Text <> '') then
  begin
      number := CurrentMaskEdit.Tag;
      name := CurrentMaskEdit.name;
      if pos('State',name) <> 0 then
        ChangeValue(vtstate, number, strtofloat(CurrentMaskEdit.text))
      else if pos('Par',name) <> 0 then
        ChangeValue(vtparameter, number, strtofloat(CurrentMaskEdit.text))
      else if number <> 0 then
        ChangeValue(vtprocess, number, strtofloat(CurrentMaskEdit.text));
   //   CurrentMaskEdit.Modified := False;
  end;
end;

{ Opens an additional window that contains all the processes in the model. }
procedure TFmCalculate.BtnShowallProcClick(Sender: TObject);
begin
 stat := currentstat;
 drive := currentdrive;
 par := currentpar;
 proc := currentproc;
 DataForm.ShowProcess;
end;

{ Calculates a new steady state based on the target variables. }
////////////////////////////////////////////////////////////////////////////////
procedure TFmCalculate.CalculateSteadyState(Sender: TObject);
var
 Ps, Gcl, Gcw, Gcr, omegaCl, omegaCw, omegaCr, omegaNl, omegaNw, omegaNr,
 omegaCa, omegaCb, omegaNa, omegaNb, Un, Tn, Gnl, Gnw, Gnr, Cs, Ci, FClambdaE,
 FClambdaI, FClambdaS, kse, kei, kie, kih, rs, beta, Rh, Fnah, Fnai, Fnhi,
 Fnahold, Fnia, Q, Qnh4, aCa, aCb, aNa, aNb, L, factor:double;
 arrayindex, num1, num2, num3:integer;
 dumproc:processarray;
 calout:textfile;
 debugss:Boolean; // When debugging set this to true to write values of variables to calss.out file.
begin
{ Calculate processes (Ftempproc) based on the new drivers, parameters, and
  states but don't overwrite Ftargetproc in case the user changed a process
  directly. Calculate values of the litterfall rate parameters first so that
  the target values of FClambdaS, FClambdaE, FClambdaI, lambdaNL, lambdaNW,
  lambdaNR can be calculated when the function processes is called. }
debugss := False;
try  {1}
 if debugss then
  begin
   assignfile(calout,'e:\projects\allocationtests\alloc332D\calss.out');
   rewrite(calout);
  end;
{ Calculate temporary process values based on the parameters and state
   variables entered into the calculate window. }
 processes(caltime,Ftargetdrive,Ftargetpar,Ftargetstat,Ftempproc,false);
{ Calculate the remaining necessary target processes based on the process values
   entered into the calculate window. These equations change only if the
   structure (i.e. the box and arrow diagram) of the model changes. }
{ First calculate new litterfall parameters based on NPP. }
try  {2}
// alambdaL, alambdaW, alambdaR
 Ftargetpar[MePar_AlambdaL.tag].value := (Ftargetproc[MeNPPl.tag].value*
        currentpar[MePar_AlambdaL.tag].value)/Ftempproc[MelambdaCL.tag].value;
        {Ftempproc[MeNPPl.tag].value};
 Ftargetpar[MePar_AlambdaW.tag].value := (Ftargetproc[MeNPPw.tag].value*
        currentpar[MePar_AlambdaW.tag].value)/Ftempproc[MelambdaCW.tag].value;
        {Ftempproc[MeNPPw.tag].value};
 Ftargetpar[MePar_AlambdaR.tag].value := (Ftargetproc[MeNPPr.tag].value*
        currentpar[MePar_AlambdaR.tag].value)/Ftempproc[MelambdaCR.tag].value;
        {Ftempproc[MeNPPr.tag].value;}

 if debugss then
  begin
  writeln(calout,'alambdaL, ',Ftargetpar[MePar_AlambdaL.tag].value);
  writeln(calout,'alambdaW, ',Ftargetpar[MePar_AlambdaW.tag].value);
  writeln(calout,'alambdaR, ',Ftargetpar[MePar_AlambdaR.tag].value);
  end;

{ Call processes to calculate litterfall rates, FclambdaI, FclambdaE, FclambdaS. }
 processes(caltime,Ftargetdrive,Ftargetpar,Ftargetstat,dumproc,false);

 // NPPt = lambdaCL + lambdaCW + lambdaCR
 Ftargetproc[MeNPPt.tag].value := dumproc[MelambdaCL.tag].value +
      dumproc[MelambdaCw.tag].value + dumproc[MelambdaCR.tag].value;
 // lambdaCL from processes procedure
 Ftargetproc[MelambdaCL.tag].value := dumproc[MelambdaCL.tag].value;
 // lambdaCW from processes procedure
 Ftargetproc[MelambdaCw.tag].value := dumproc[MelambdaCw.tag].value;
 // lambdaCR from processes procedure
 Ftargetproc[MelambdaCR.tag].value := dumproc[MelambdaCR.tag].value;  
 // Rp = GPP - NPPt
 Ftargetproc[MeRpt.tag].value := Ftargetdrive[MeDrivePs.Tag].value -
                                  Ftargetproc[MeNPPt.tag].value;

 if debugss then
  begin
   writeln(calout,'Nppt, ',Ftargetproc[MeNPPt.tag].value);
   writeln(calout,'lambdaCL, ',Ftargetproc[MelambdaCL.tag].value);
   writeln(calout,'lambdaCw, ',Ftargetproc[MelambdaCw.tag].value);
   writeln(calout,'lambdaCr, ',Ftargetproc[MelambdaCr.tag].value);
   writeln(calout,'Rpt, ',Ftargetproc[MeRpt.tag].value);
  end;

 // Tn
 Ftargetproc[MeTn.tag].value := dumproc[MeTn.tag].value;
 if debugss then
   writeln(calout,'Tn, ',Ftargetproc[MeTn.tag].value);

// Nw
 // lambdaNL from processes procedure
 Ftargetproc[MelambdaNL.tag].value := dumproc[MelambdaNL.tag].value;
 // lambdaNR from processes procedure
 Ftargetproc[MelambdaNR.tag].value := dumproc[MelambdaNR.tag].value;
 if debugss then
   writeln(calout,'lambdaNL, ',Ftargetproc[MelambdaNL.tag].value);
 if debugss then
   writeln(calout,'lambdaNr, ',Ftargetproc[MelambdaNr.tag].value);

// Backcalculated parameters
                                                                            
// lambdaNW := Un - lambdaNL - lambdaNR
 Ftargetproc[MelambdaNW.tag].value := Ftargetdrive[MeDriveUnh4.tag].value -
     Ftargetproc[MelambdaNL.tag].value - Ftargetproc[MelambdaNR.tag].value;
 if debugss then
   writeln(calout,'lambdaNw, ',Ftargetproc[MelambdaNw.tag].value);
// Nw := lambdaNW*Cw/lambdaCW
 Ftargetstat[MeStateNw.tag].value := Ftargetproc[MelambdaNW.tag].value*
     Ftargetstat[MeStateCw.tag].value/Ftargetproc[MelambdaCW.tag].value;
 if debugss then
   writeln(calout,'Nw, ',Ftargetstat[MeStateNw.tag].value);

{ Use currentproc not tempproc for old values in this equation because the
  values in tempproc are based partly on old values and partly on new values. }
 arrayindex := GetArrayIndex(vtprocess,'Qr');
 Ftargetpar[MePar_rm.tag].value := (Ftargetproc[MeRpt.tag].value -
     0.25*Ftargetproc[MeNPPt.tag].value)/(Ftargetproc[arrayindex].value*
     (Ftargetstat[MeStateNl.tag].value + Ftargetstat[MeStateNw.tag].value +
     Ftargetstat[MeStateNr.tag].value));
 if debugss then
   writeln(calout,'rm, ',Ftargetpar[MePar_rm.tag].value);

{ Calculate metabolic respiration in leaves roots and stems by calling processes
  and then calculate total respiration. Finally calculate the allocation fluxes. }
 processes(caltime,Ftargetdrive,Ftargetpar,Ftargetstat,dumproc,false);

// Ri = Rigr + Rimet
 arrayindex := GetArrayIndex(vtProcess, 'Rl');
 num1 := GetArrayIndex(vtProcess, 'Rlmet');
 Ftargetproc[arrayindex].value := 0.25*Ftargetproc[MeNPPl.tag].value +
     dumproc[num1].value;
 if debugss then
   writeln(calout,'Rl, ',Ftargetproc[arrayindex].value);
 arrayindex := GetArrayIndex(vtProcess, 'Rw');
 num1 := GetArrayIndex(vtProcess, 'Rwmet');
 Ftargetproc[arrayindex].value := 0.25*Ftargetproc[MeNPPw.tag].value +
     dumproc[num1].value;
 if debugss then
   writeln(calout,'Rw, ',Ftargetproc[arrayindex].value);
 arrayindex := GetArrayIndex(vtProcess, 'Rr');
 num1 := GetArrayIndex(vtProcess, 'Rrmet');
 Ftargetproc[arrayindex].value := 0.25*Ftargetproc[MeNPPr.tag].value +
     dumproc[num1].value;
 if debugss then
   writeln(calout,'Rr, ',Ftargetproc[arrayindex].value);

// Gcl = lambdaCL + Rl
 arrayindex := GetArrayIndex(vtProcess, 'Rl');
 Gcl := Ftargetproc[MelambdaCL.tag].value + Ftargetproc[arrayindex].value;
// Gcr = lambdaCR + Rr
 arrayindex := GetArrayIndex(vtProcess, 'Rr');
 Gcr := Ftargetproc[MelambdaCR.tag].value + Ftargetproc[arrayindex].value;
 if debugss then
  begin
   writeln(calout,'Gcl, ',Gcl);
   writeln(calout,'Gcr, ',Gcr);
  end;
// Gnl = lambdaNL + Tn
 Gnl := Ftargetproc[MelambdaNL.tag].value + Ftargetproc[MeTn.tag].value;

// Gnr = lambdaNR
 Gnr := Ftargetproc[MelambdaNR.tag].value;
 if debugss then
  begin
   writeln(calout,'Gnl, ',Gnl);
   writeln(calout,'Gnr, ',Gnr);
  end;

//***************************************************************************
{ These equations must be changed whenever changes are made to the allocation
  equations in GEM. }
// Using temporary variables in these equations to make them easier to read.

 Ps := Ftargetdrive[MeDrivePs.tag].value;
 arrayindex := GetArrayIndex(vtProcess, 'omegaCL');
 omegaCL := Ftempproc[arrayindex].value;
 arrayindex := GetArrayIndex(vtProcess, 'omegaCW');
 omegaCW := dumproc[arrayindex].value;
 arrayindex := GetArrayIndex(vtProcess, 'omegaCR');
 omegaCR := Ftempproc[arrayindex].value;
 if debugss then
  begin
   writeln(calout,'omegaCL, ',omegacl);
   writeln(calout,'omegaCw, ',omegacw);
   writeln(calout,'omegaCr, ',omegacr);
  end;

 Un := Ftargetdrive[MeDriveUnh4.tag].value;
 Tn := Ftargetproc[MeTn.tag].value;
 arrayindex := GetArrayIndex(vtProcess, 'omegaNL');
 omegaNL := Ftempproc[arrayindex].value;
 arrayindex := GetArrayIndex(vtProcess, 'omegaNW');
 omegaNW := dumproc[arrayindex].value;
 arrayindex := GetArrayIndex(vtProcess, 'omegaNR');
 omegaNR := Ftempproc[arrayindex].value;
 if debugss then
  begin
   writeln(calout,'omeganL, ',omeganl);
   writeln(calout,'omeganw, ',omeganw);
   writeln(calout,'omeganr, ',omeganr);
  end;

 L := Ftargetpar[MePar_ml.tag].value/Ftargetstat[MeStateCl.tag].value;
 arrayindex := GetArrayIndex(vtProcess, 'Csw');
 factor := (L*L)/Ftempproc[arrayindex].value;

// omegaCa
 arrayindex := GetArrayIndex(vtParameter, 'aCa');
 Ftargetpar[arrayindex].value := {factor*}(omegaCw*((Ps - Gcr)/Gcl - 1) -
                                          omegaCl)/(1-(Ps/Gcl));
 aCa := Ftargetpar[arrayindex].value;
 omegaCa := aCa{/factor};
// omegaCb
 arrayindex := GetArrayIndex(vtParameter, 'aCb');
 Ftargetpar[arrayindex].value := {factor*}(omegaCw*(omegaCl*(Ps/Gcr - 1) -
                          omegaCa) - omegaCr*(omegaCl +
                          omegaCw + omegaCa))/(omegaCl + omegaCw + omegaCa);
 if debugss then
  begin
   writeln(calout,'omegaCa, ',omegaca);
   writeln(calout,'omegaCb, ',Ftargetpar[arrayindex].value);
  end;

// omegaNa
 arrayindex := GetArrayIndex(vtParameter, 'aNa');
 Ftargetpar[arrayindex].value := {factor*}(omegaNw*((Un + Tn - Gnr)/Gnl - 1) -
                                          omegaNl)/(1 - Tn/Gnl);
 aNa := Ftargetpar[arrayindex].value;
 omegaNa := aNa{/factor};
// omegaNb
 arrayindex := GetArrayIndex(vtParameter, 'aNb');
 Ftargetpar[arrayindex].value := {factor*}(Gnr*(omegaNw*(omegaNL+omegaNa)+
     (omegaNL + omegaNw + omegaNa)*omegaNR) - omegaNW*(omegaNL*(Un + Tn)+
     omegaNa*Un))/((omegaNL + omegaNw + omegaNa)*(Un-Gnr));
 if debugss then
  begin
   writeln(calout,'omegana, ',omegana);
   writeln(calout,'omeganb, ',Ftargetpar[arrayindex].value);
  end;
//***************************************************************************

 if debugss then closefile(calout);

 try  {3}
  CheckAlloc := True;
 processes(caltime,Ftargetdrive,Ftargetpar,Ftargetstat,currentproc,false);
 currentpar := Ftargetpar;
 currentstat := Ftargetstat;
 currentdrive := Ftargetdrive;
// Set up for next call to calculatesteadystate.
 Ftargetproc := currentproc;
 Ftargetproc[MeNPPl.tag].value := Ftargetproc[MeLambdaCL.tag].value;
 Ftargetproc[MeNPPw.tag].value := Ftargetproc[MeLambdaCW.tag].value;
 Ftargetproc[MeNPPr.tag].value := Ftargetproc[MeLambdaCR.tag].value;
 currentproc[MeNPPl.tag].value := Ftargetproc[MeNPPl.tag].value;
 currentproc[MeNPPw.tag].value := Ftargetproc[MeNPPw.tag].value;
 currentproc[MeNPPr.tag].value := Ftargetproc[MeNPPr.tag].value;
 except {3}
 on E: ECalculateError do
  begin
   currentproc := Ftargetproc;
   raise ECalcNewProcess.Create('Error calculating new processes. ' +
        'New values of parameters, states and processes (except NPPl, NPPw, ' +
        'NPPr, and NPPt) are now shown in the window. Additional Info: '
         + E.Message);
  end;
 end;
 except {2}
 on ECalcNewProcess do raise;
 on E: EMathError do
  begin
   currentpar := Ftargetpar;
   currentstat := Ftargetstat;
   currentdrive := Ftargetdrive;
   raise ECalcNewValue.Create('Error calculating new parameter or state ' +
        'variable. New values of parameters and states but old values of the' +
        ' processes are now shown in the window. Additional Info: ' + E.Message);
  end;
end;
except {1}
 on ECalcNewValue do raise;
 on ECalcNewProcess do raise;
 // otherwise
 on E: EMathError do
  begin
   raise ECalcInitialProc.Create('Unable to calculate initial process values ' +
        'using entered data. Parameter, state variables, and processes have '
        + 'been set to their previous values. Additional Info: ' + E.Message);
  end;
end;
end;

{ Checks if the values in the enabled maskedits are negative and returns false
  if they are.}
function TFmCalculate.CheckValue(Sender:TObject):Boolean;
var
 temp:Boolean;
 CurrentMaskEdit:TMaskEdit;
begin
 temp := True;
 CurrentMaskEdit := Sender as TMaskEdit;
 try
   if strtofloat(CurrentMaskEdit.text) < 0 then temp := False;
 except
   temp := False;
 end;
{ with FmCalculate do
  begin // with block
   for i := 0 to ComponentCount - 1 do
    if (Components[i] is TMaskEdit) and (TMaskEdit(Components[i]).enabled) then
      if strtofloat(TMaskEdit(Components[i]).text) < 0 then temp := False;
  end; // with block }

 CheckValue := temp;
end;

{ Stores the current values in the maskedits in the appropriate arrays. }
procedure TFmCalculate.UpdateFormValues;
var
 i:integer;
 CurrentMaskEdit:TMaskEdit;
begin
 with FmCalculate do
 begin // with block
  for i := 0 to ComponentCount - 1 do
   if Components[i] is TMaskEdit then
    begin
     CurrentMaskEdit := Components[i] as TMaskEdit;
     if pos('State', CurrentMaskEdit.Name) <> 0  then      // State
      begin
       CurrentMaskEdit.text :=
            floattostrf(currentstat[CurrentMaskEdit.tag].value,ffgeneral,6,4);
      end
     else if pos('Drive', CurrentMaskEdit.Name) <> 0 then   // Driver
      begin
       CurrentMaskEdit.text :=
            floattostrf(currentdrive[CurrentMaskEdit.Tag].value,ffgeneral,6,4);
      end
     else if pos('Par', CurrentMaskEdit.Name) <> 0 then    // Parameter
      begin
       CurrentMaskEdit.text :=
            floattostrf(currentpar[CurrentMaskEdit.Tag].value,ffgeneral,6,4);
      end
     else                                     // Process
      begin
       CurrentMaskEdit.text :=
            floattostrf(currentproc[CurrentMaskEdit.Tag].value,ffgeneral,6,4);
      end;
    end;   // if component is Tmaskedit
 end; // with block
end;

{ Stores the value entered into the current maskedit when user presses enter. }
procedure TFmCalculate.GeneralKeyPress(Sender: TObject; var Key: Char);
begin
 if (Sender is TMaskEdit) and (Key = Chr(13)) then StoreValue(Sender);
end;

{ Save the current values in the window to the previously selected parameter
  file. }
procedure TFmCalculate.BtnSaveParamFileClick(Sender: TObject);
begin
if FoverwriteConfirmed = False then
 begin
  if MessageDlg('Overwrite existing parameter file?',mtConfirmation,
   [mbYes,mbNo], 0) = mrYes then
   begin
  { Copy current arrays into global arrays so that code can use the
    saveparamclick procedure in frontend. }
     stat := currentstat;
     par := currentpar;
     MainForm.MISaveParamClick(FmCalculate.BtnSaveParamFile);
     FoverwriteConfirmed := True;
   { Replace values in the original arrays so that if the user clicks cancel,
     they will revert to the last saved values (as expected) and not some
     previous parameter set. }
     Foriginalstat := currentstat;
     Foriginalpar := currentpar;
   end
  else
   begin
     MessageDlg('No values saved.',mtWarning, [mbOK], 0);
   end;
 end
else
 begin
  { Copy current arrays into global arrays so that code can use the
    saveparamclick procedure in frontend. }
   stat := currentstat;
   par := currentpar;
   MainForm.MISaveParamClick(FmCalculate.BtnSaveParamFile);
   { Replace values in the original arrays so that if the user clicks cancel,
     they will revert to the last saved values (as expected) and not some
     previous parameter set. }
   Foriginalstat := currentstat;
   Foriginalpar := currentpar;
 end;
end;

procedure TFmCalculate.BtnOKClick(Sender: TObject);
begin
 stat := currentstat;
 par := currentpar;
 proc := currentproc;
 drive := currentdrive;

 if not MainForm.RunningSensitivity then
   if DataForm.Visible = True then DataForm.Hide;
end;

{ This function allows parameter, process and state variable values to be
  changed from outside the steady state window. It's necessary because the
  Ftarget variables are private. Currently it's used for the sensitivity test.}
procedure TFmCalculate.ChangeValue(VarType:TVarType; arraynum:integer;
               newvalue:double);
begin
 case VarType of
   vtParameter:
    begin
      Ftargetpar[arraynum].value := newvalue;
    end;
   vtDriver:
    begin
      Ftargetdrive[arraynum].value := newvalue;
    end;
   vtState:
    begin
     Ftargetstat[arraynum].value := newvalue;
    end;
   vtProcess:
    begin
     Ftargetproc[arraynum].value := newvalue;
    end;
 end;
 UpdateForm(FmCalculate, True);
end;

{ Function to search the global arrays for a particular variable. Returns the
  array index of the specified variable. Returns a zero if the variable was not
  found. }
function TFmCalculate.GetArrayIndex(VarType:TVarType; symbol: string):Integer;
var
 i, number:integer;
begin
 number := 0;
 case VarType of
   vtParameter:
    begin
     for i := 1 to ModelDef.numparam do
      begin
        if symbol = par[i].symbol then number := i;
      end;
    end;
   vtDriver:
    begin
     for i := 1 to ModelDef.numdrive do
      begin
        if symbol = drive[i].symbol then number := i;
      end;
    end;
   vtState:
    begin
     for i := 1 to ModelDef.numstate do
      begin
        if symbol = stat[i].symbol then number := i;
      end;
    end;
   vtProcess:
    begin
     for i := ModelDef.numstate to ModelDef.numprocess do
      begin
        if symbol = proc[i].symbol then number := i;
      end;
    end;
 end;
 
 if number <> 0 then
   GetArrayIndex := number
 else
//   raise Exception.Create('Could not find symbol, ' + symbol + ' in array.');
end;

procedure TFmCalculate.EnableGroupBoxes(Sender: TObject);
begin
 GbAllocation.Enabled := True;
{ GbDriver.Enabled := True;
 GbNPP.Enabled := True;
 GbPResp.Enabled := True;
 GbSapwood.Enabled := True;
 GbState.Enabled := True;
 GbStatus.Enabled := True;
 GbTranslocation.Enabled := True;     }
end;

procedure TFmCalculate.DisableGroupBoxes(Sender: TObject);
begin
 GbAllocation.Enabled := False;
{ GbDriver.Enabled := False;
 GbNPP.Enabled := False;
 GbPResp.Enabled := False;
 GbSapwood.Enabled := False;
 GbState.Enabled := False;
 GbStatus.Enabled := False;
 GbTranslocation.Enabled := False;     }
end;

end.

